



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C# 重构</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C# 重构</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 16:14:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>重构是在编写代码后在不更改代码的外部行为的前提下通过更改代码的内部结构来改进代码的过程。</p>
<p>一、何时需要重构</p>
<p>1、代码中存在重复的代码；</p>
<blockquote><p>如果类中有重复的代码块，需将其提炼出一个新的独立方法，如果是不同类中具有相同的代码，将其提炼成一个新类。</p></blockquote>
<p>2、过大的类和过长的方法；</p>
<blockquote><p>过大的类往往是类抽象不合理的结果，类抽象不合理将降低代码的复用率。当看到一个过长的方法时，需要想办法将其划分为多个小方法。</p>
<p>方法中的代码行数越多，则方法越难理解。我们推荐每个方法中只包含 20-25 行代码。但有些人说 1-10 行更合理，这只是些个人喜好，没有硬性的规则。抽取方法是最常见的重构方式之一。如果你发现一个方法过长，或者已经需要一个注释来描述它的目的了，那么你就可以应用抽取方法了。人们总是会问一个方法到底多长合适，但其实长度并不是问题的根源。当你在处理复杂的方法时，跟踪所有局部变量是最复杂和消耗时间的，而通过抽取一个方法可以节省一些时间。可以使用 Visual Studio 来抽取方法，它会帮助你跟踪局部变量，并将其传递给新的方法或者接收方法的返回值。</p></blockquote>
<p>3、牵一发而动全身的修改；</p>
<blockquote><p>修改一个小功能，或增加一个小功能时，就引发一次代码地震，也许是你的设计抽象度不够理想，功能代码太过分散所引起的。</p></blockquote>
<p>4、类之间需要过多的通讯；</p>
<blockquote><p>A 类需要调用B 类的过多方法访问B 的内部数据，是不是这两个类根本就不应该分开。</p></blockquote>
<p>5、过度耦合的信息链；</p>
<blockquote><p>代码中常常会使用中间层来达到松耦合的目的，但过多的中间层，层层相连，是否需要考虑减少中间层。</p></blockquote>
<p>6、功能相似的类或方法；</p>
<p>7、不完美的设计；</p>
<p>8、缺少必要的注释；</p>
<p>9、始终控制类的大小</p>
<p>　　超大的类在尝试做太多的事情，这违反了单一职责原则（SRP），也就是面向对象设计原则 SOLID 中的 S。</p>
<p>　　为什么一定要将两个职责分离到单独的类中呢？因为每一个职责都是变化的中心。在需求变更时，这个变更将会出现在负责该职责的类中。如果一个类承担了多个职责，就会有一个以上的原因导致其变化。如果一个类有多重职责，则说明这些职责已经耦合到了一起。并且某个职责的变化将有可能削弱或限制这个类满足其他职责的能力。这种耦合将会导致非常脆弱的设计，进而在职责发生变化时，设计可能被意想不到的破坏了。</p>
<p>下面两条可以归为重写范畴，代码规范问题。</p>
<p>10、避免过多的参数</p>
<p>　　通过声明一个类来代替多个参数。创建一个类，用于包含所有的参数。通常来讲，这是一个较好的设计，并且这个抽象非常的有价值。</p>
<p>11、避免复杂的表达式</p>
<p>　　复杂的表达式意味着其背后隐藏了一些涵义，我们可以通过使用属性来封装这些表达式，进而使代码更易读些。　</p>
<div>
<pre class="prettyprint linenums">if(product.Price&gt; &amp;&amp; !product.IsDeleted &amp;&amp;<br />
 !product.IsFeatured &amp;&amp; product.IsExported)<br />
 {<br />
    // do something<br />
 }</pre>
</div>
<p>二、C# VS2010中的几点重构</p>
<p><a href="https://msdn.microsoft.com/zh-CN/library/0s21cwxk.aspx" rel="external nofollow noreferrer">1、提取方法重构</a></p>
<p><a href="https://msdn.microsoft.com/zh-cn/library/6kxxabwd.aspx" rel="external nofollow noreferrer">2、重命名重构</a></p>
<p><a href="https://msdn.microsoft.com/zh-cn/library/a5adyhe9.aspx" rel="external nofollow noreferrer">3、封装字段重构</a></p>
<p><a href="https://msdn.microsoft.com/zh-cn/library/fb3dyx26.aspx" rel="external nofollow noreferrer">4、提取接口重构</a></p>
<p><a href="https://msdn.microsoft.com/zh-cn/library/0c7wac46.aspx" rel="external nofollow noreferrer">5、移除参数重构</a></p>
<p><a href="https://msdn.microsoft.com/zh-cn/library/5ss5z206.aspx" rel="external nofollow noreferrer">6、重新排列参数重构</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2n7jlq.html">35&period; Search Insert Position</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql3r60q.html">Nginx-uri、request&lowbar;uri、document&lowbar;uri之间的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1noo59.html">oracle sql语句跟踪</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdek4dv9.html">实现CCLayer只显示一个矩形可见区域</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1wz7x9.html">OA项目之左导航</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w6dpxq.html">php删除最后一个字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w6xvlq.html">Java设计模式07：常用设计模式之装饰器模式（结构型模式）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wn0noq.html">MySQL的多实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn17n1k8.html">&lbrack;C&plus;&plus;程序设计&rsqb;有关形参与实参&comma;及返回值说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1d41m9.html">Android项目 手机安全卫士（代码最全，注释最详细）之十二 设置中心的界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd534y9.html">all unicode</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1mw7jq.html">SOFA 源码分析 &mdash; 调用方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjekn09.html">100-days&colon; twenty-one</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwv25k8.html">用 JS 写 （轮播图 &sol; 选项卡 &sol; 滑动门）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwym6y8.html">8、JPA-映射-双向一对一</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wrm2rq.html">LeetCode&colon; Recover Binary Search Tree  解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r3k0z8.html">C&plus;&plus;基础知识：异常处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ork2j8.html">Python---Pycharm如何直接上传自己的代码到GitHub</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkgkwn8.html">Sqoop学习之路 （一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppn5y79.html">【LeetCode】数组--合并区间（56）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pmjm749.html">linux下端口被占用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zv1rpx9.html">【Git】无法从远程分支pull</a>
			</li>
						<li><a href="https://www.batexi.com/a/qd5eodx9.html">enum枚举类型的定义</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e01jvkq.html">如何创建一个基于 MSBuild Task 的跨平台的 NuGet 工具包</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mdnkm28.html">Redis缓存的设计、性能、应用与数据集群同步</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy2d6vj9.html">CentOS编译安装php7&period;2</a>
			</li>
						<li><a href="https://www.batexi.com/a/95px7m0q.html">homeland  开源论坛系统搭建试用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9je0xw08.html">arm&lowbar;linux QT&plus;v4l 显示视频</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwodx0y9.html">python-生成测试报告-然后自动发送邮件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvdvo2jq.html">sphinx-1&period;3&period;0扩展在pPHP 7&period;0&period;7版本编译不通过</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
